# std::optional<T>::begin

From cppreference.com
< cpp‎ | utility‎ | optional

constexpr iterator begin() noexcept; |  | (since C++26)
constexpr const_iterator begin() const noexcept; |  | (since C++26)

If *this contains a value, returns an iterator to the contained value. Otherwise, a past-the-end iterator value.

### Parameters

(none)

### Return value

Iterator to the contained value if has_value() is true. Otherwise, a past-the-end iterator.

### Complexity

Constant.

### Notes

Feature-test macro | Value | Std | Feature
--- | --- | --- | ---
`__cpp_lib_optional_range_support` | `202406L` | (C++26) | Range support for `std::optional`

### Example

Run this code

    #include <optional>
    #include <print>
    #include <vector>

    int main()
    {
        constexpr std::optional<int> none = std::nullopt;
        constexpr std::optional<int> some = 42;

        static_assert(none.begin() == none.end());
        static_assert(some.begin() != some.end());

        // ranged-for loop support
        for (int i : none)
            std::println("'none' has a value of {}", i);

        for (int i : some)
            std::println("'some' has a value of {}", i);

        std::optional<std::vector<int>> many({0, 1, 2});
        for (const auto& v : many)
            std::println("'many' has a value of {}", v);
    }

Output:

    'some' has a value of 42
    'many' has a value of [0, 1, 2]

### See also

end (C++26) | returns an iterator to the end (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/utility/optional/begin&oldid=173902"